#Timmy code

#general stuff
rm(list=ls()) #+ctrl L for clearing the workspace

#PACKAGES TO INSTALL
#source("https://eur04.safelinks.protection.outlook.com/?url=http%3A%2F%2Fbioconductor.org%2FbiocLite.R&amp;data=02%7C01%7C%7C0131c697a3934d5fc72508d6128ab3eb%7C84df9e7fe9f640afb435aaaaaaaaaaaa%7C1%7C0%7C636716784256644491&amp;sdata=T%2FH0pwiZmhR0R9UGyubb7dP2Qo9SG%2BSnR2mrHMG6JxI%3D&amp;reserved=0")
#biocLite("Biostrings") #for working with genetic material in R
#install.packages("devtools") # if you have not installed "devtools" package #For easy saving for loop output
#devtools::install_github("hoxo-m/magicfor")
#install.packages("seqinr") #for the read and write fasta functions

#PACKAGES TO LOAD
require(Biostrings) #revise if needed
library(magicfor)
library(seqinr)

#VARIABLES TO SET
setwd("/home/gemma/Documents/iGEM/RstudioiGEM/sequencegenerator") #set working directory to where you have your sequence saved and would like to save the generated file
Gene <- "EPOcDNAv2_582bps.fasta" #insert file name HERE
Junctions <- c(159,246,426) #positions of the junctions in bps
outfile <- "EPOcDNAgRNAsv1.fasta" #name of output file
  # Features of Cas you are working with
Cas_PAM <-'g'         # PAM sequence for Cas Small letter!
Cas_PAM_rev <-'c'     # PAM sequence for Cas, reverse strand Small letter!
N <- 1                 # Number of N in PAM behind Cas_PAM (eg. NG has N=1)
gRNA_size <-20        # Size of gRNA for Cas
Cas_on_target <-10   # Number of bp that have to be identical next to PAM

#####################################################################
############### RUN FROM HERE ON SHOULD BE AUTOMATIC#################

## Translating DNA to aa
Gene <- read.fasta(Gene, as.string = TRUE)
Gene <- as.character(Gene)
Gene <- strsplit(Gene, NULL)
Gene <-unlist(Gene)
Gene_aa <-translate(Gene)

#make Poss_cod
magic_for()
for (i in Gene_aa){
  codons <- names(GENETIC_CODE[GENETIC_CODE==i])
  x1 <- length(codons)
  put(x1)
}
 Poss_cod <-magic_result_as_vector()
 
# make Gene_num
Gene_num<- lapply(Gene,function(ch) gsub("a", "1", ch))
Gene_num <- lapply(Gene_num,function(ch) gsub("t", "2", ch)) 
Gene_num <- lapply(Gene_num,function(ch) gsub("c", "3", ch)) 
Gene_num <- lapply(Gene_num,function(ch) gsub("g", "4", ch))
Gene_num <- lapply(Gene_num,function(ch) gsub("n", "0", ch)) 
Gene_num <- unlist(Gene_num)
#make Cas_PAM
Cas_PAM_num<- lapply(Cas_PAM,function(ch) gsub("a", "1", ch)) 
Cas_PAM_num <- lapply(Cas_PAM_num,function(ch) gsub("t", "2", ch)) 
Cas_PAM_num <- lapply(Cas_PAM_num,function(ch) gsub("c", "3", ch)) 
Cas_PAM_num <- lapply(Cas_PAM_num,function(ch) gsub("g", "4", ch))
Cas_PAM_num <- lapply(Cas_PAM_num,function(ch) gsub("n", "0", ch))
Cas_PAM_num <- unlist(Cas_PAM_num)
#make Cas_PAM_rev_num
Cas_PAM_rev_num<- lapply(Cas_PAM_rev,function(ch) gsub("a", "1", ch))
Cas_PAM_rev_num <- lapply(Cas_PAM_rev_num,function(ch) gsub("t", "2", ch)) 
Cas_PAM_rev_num<- lapply(Cas_PAM_rev_num,function(ch) gsub("c", "3", ch)) 
Cas_PAM_rev_num <- lapply(Cas_PAM_rev_num,function(ch) gsub("g", "4", ch))
Cas_PAM_rev_num <- lapply(Cas_PAM_rev_num,function(ch) gsub("n", "0", ch)) 
Cas_PAM_rev_num <- unlist(Cas_PAM_rev_num)

#Search possible PAM sequences +/- 20 bp from junction. Then find possible gRNAs.

#Search gRNAs with PAM in strand 5' to 3' : 5'PAM3'
magic_free()
gRNA_position <- numeric()  #Position in gene for gRNA
gRNA_possible<- numeric() # How many possible gRNA in this position
b <-1
for (i in 1:length(Junctions)){
  for (j in c(-20:20)){
    if(Gene_num[Junctions[i]+j]==Cas_PAM_num){
      gRNA_position[b] <- Junctions[i]+j
      gRNA_possible[b] <- prod(Poss_cod[floor((Junctions[i]+j-N-Cas_on_target)/3):ceiling((Junctions[i]+j-2)/3)])
      b <-b+1
      }
  }
}

#Search gRNAs with PAM in strand 3' to 5' : 3'PAM5'
gRNA_position_rev <- numeric()  #Position in gene for gRNA
gRNA_possible_rev<- numeric() # How many possible gRNA in this position
b <-1
for (i in 1:length(Junctions)){
  for (j in c(-20:20)){
    if(Gene_num[Junctions[i]+j]==Cas_PAM_rev_num){
      gRNA_position_rev[b] <- Junctions[i]+j
      gRNA_possible_rev[b] <- prod(Poss_cod[ceiling((Junctions[i]+j+(N+1))/3):ceiling((Junctions[i]+j+(N+1)+Cas_on_target)/3)])
      b <-b+1
    }
  }
}

# Put together position and possible guides.
names(gRNA_possible) <- gRNA_position #name vector 
names(gRNA_possible_rev) <- gRNA_position_rev #name vector 
gRNA<- c(gRNA_possible, gRNA_possible_rev) #combine vector with names (positions)
min_gRNA <- min(gRNA) # Find the smaller number of variations for gRNAs
min_gRNA_Geneposs <- names(which(gRNA==min(gRNA))) #Find position(s) in Gene_num that has this PAM sequence with small variation of gRNAs.
min_gRNA_Geneposs <- as.numeric(min_gRNA_Geneposs) #make numerical to work with logical operators in loop

#generate and export gRNA sequences
gRNA_list <-list()
for (i in (1:length(min_gRNA_Geneposs))){ # How many positions with small possibilities
  if (any(min_gRNA_Geneposs[i]==gRNA_position_rev)){ # This would be PAM on reverse strands, look if i is found in gRNA_position_rev
    if (min_gRNA_Geneposs[i]%%3 == 0) { #PAM divided by 3 means final part of codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target+1)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)+1):(ceiling(min_gRNA_Geneposs[i]/3)+jj))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
      }#3: if devided by 3
    else if ((min_gRNA_Geneposs[i]-1)%%3 == 0) { #PAM starts new codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target-1)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)+1):(ceiling(min_gRNA_Geneposs[i]/3)+jj))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
    }#3: if PAM starts new codon
    else if ((min_gRNA_Geneposs[i]+1)%%3 == 0) { #PAM in middle codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)+1):(ceiling(min_gRNA_Geneposs[i]/3)+jj))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp 
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
    }#3: if PAM is in middle codon
  } #2: if TRUE
  else { #2: if FALSE: PAM on fw strand
    if (min_gRNA_Geneposs[i]%%3 == 0) { #PAM divided by 3 means final part of codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target-1)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)-jj):(ceiling(min_gRNA_Geneposs[i]/3)-1))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
    }#3: if devided by 3
    else if ((min_gRNA_Geneposs[i]-1)%%3 == 0) { #PAM starts new codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target+1)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)-jj):(ceiling(min_gRNA_Geneposs[i]/3)-1))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
    }#3: if PAM starts new codon
    else if ((min_gRNA_Geneposs[i]+1)%%3 == 0) { #PAM in middle codon
      sequence <- data.frame () #predefined dataframe that will contain the gRNA sequences
      jj <- ceiling((Cas_on_target)/3)
      aa_sequence <-Gene_aa[(ceiling((min_gRNA_Geneposs[i]/3)-jj):(ceiling(min_gRNA_Geneposs[i]/3)-1))]
      temp <- vector ()
      codons1 <- list ()
      for (aa in 1:length(aa_sequence)){
        temp <- names(GENETIC_CODE[GENETIC_CODE==aa_sequence[aa]])
        codons1[[length(codons1)+1]] <- temp
      }
      sequence <- expand.grid(codons1) #generate all gRNAs in a dataframe
      PAMseq <- Gene[(min_gRNA_Geneposs[i]-2):min_gRNA_Geneposs[i]] #generating PAM sequence
      PAMseq <- paste0(PAMseq, collapse = "") 
      sequence <- cbind(PAMseq,sequence) #adding PAM sequence to dataframe
      cols <- c(names(sequence))
      sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
      sequence <- sequence[ , !( names(sequence) %in% cols ) ]
      sequence <- strsplit(sequence, NULL) 
    }#3: if PAM is in middle codon
  }#2: PAM on fw strand
  gRNA_list [i] <-list(sequence, i) #lists all sequences
} #1: min_gRNA_Geneposs
gRNA_list <- unlist(gRNA_list, recursive = FALSE)
write.fasta(sequences = gRNA_list, names = names(names), file.out = outfile) 

